package com.company.traits.entity;

import io.jmix.core.metamodel.annotation.Composition;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import jakarta.persistence.*;

import java.util.List;

@JmixEntity
@Table(name = "tTaxaTraitsCategories")
@Entity
public class TTaxaTraitsCategory {
	@InstanceName
	@Column(name = "ttcCategoryName", nullable = false, length = 50)
	@Id
	private String ttcCategoryName;

	@Composition
	@OneToMany(mappedBy = "tttCategoryName")
	private List<TTaxaTraitsType> tTaxaTraitsType;
	@Column(name = "ttcGuid", length = 36)
	private String ttcGuid;

	public List<TTaxaTraitsType> getTTaxaTraitsType() {
		return tTaxaTraitsType;
	}

	public void setTTaxaTraitsType(List<TTaxaTraitsType> tTaxaTraitsType) {
		this.tTaxaTraitsType = tTaxaTraitsType;
	}

	public String getTtcGuid() {
		return ttcGuid;
	}

	public void setTtcGuid(String ttcGuid) {
		this.ttcGuid = ttcGuid;
	}

	public String getTtcCategoryName() {
		return ttcCategoryName;
	}

	public void setTtcCategoryName(String ttcCategoryName) {
		this.ttcCategoryName = ttcCategoryName;
	}
}