package com.company.traits.entity.key;

import io.jmix.core.MetadataTools;
import io.jmix.core.metamodel.annotation.DependsOnProperties;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import jakarta.persistence.Column;
import jakarta.persistence.Embeddable;

import java.util.Objects;

@JmixEntity
@Embeddable
public class TTaxaTraitsTypeCompKey {
	@Column(name = "tttCategoryName", nullable = false, unique = true, length = 50)
	private String tttCategoryName;

	@Column(name = "tttTypeValue", nullable = false, unique = true, length = 30)
	private String tttTypeValue;

	public String getTttTypeValue() {
		return tttTypeValue;
	}

	public void setTttTypeValue(String tttTypeValue) {
		this.tttTypeValue = tttTypeValue;
	}

	public String getTttCategoryName() {
		return tttCategoryName;
	}

	public void setTttCategoryName(String ttcCategoryName) {
		this.tttCategoryName = ttcCategoryName;
	}

	@Override
	public int hashCode() {
		return Objects.hash(tttTypeValue, tttCategoryName);
	}

	@Override
	public boolean equals(Object o) {
		if (this == o) return true;
		if (o == null || getClass() != o.getClass()) return false;
		TTaxaTraitsTypeCompKey entity = (TTaxaTraitsTypeCompKey) o;
		return Objects.equals(this.tttTypeValue, entity.tttTypeValue) &&
				Objects.equals(this.tttCategoryName, entity.tttCategoryName);
	}

	@InstanceName
	@DependsOnProperties({"tttCategoryName", "tttTypeValue"})
	public String getInstanceName(MetadataTools metadataTools) {
		return String.format("%s %s",
				metadataTools.format(tttCategoryName),
				metadataTools.format(tttTypeValue));
	}
}